/* Include files */

#include "sl_househeat_sfun.h"
#include "sl_househeat_sfun_debug_macros.h"
#include "c1_sl_househeat.h"
#include "c2_sl_househeat.h"
#include "c4_sl_househeat.h"
#include "c6_sl_househeat.h"
#include "c7_sl_househeat.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
uint32_T _sl_househeatMachineNumber_;
real_T _sfTime_;

/* Function Declarations */

/* Function Definitions */
void sl_househeat_initializer(void)
{
}

void sl_househeat_terminator(void)
{
}

/* SFunction Glue Code */
unsigned int sf_sl_househeat_method_dispatcher(SimStruct *simstructPtr, unsigned
  int chartFileNumber, const char* specsCksum, int_T method, void *data)
{
  if (chartFileNumber==1) {
    c1_sl_househeat_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==2) {
    c2_sl_househeat_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==4) {
    c4_sl_househeat_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==6) {
    c6_sl_househeat_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==7) {
    c7_sl_househeat_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  return 0;
}

unsigned int sf_sl_househeat_process_check_sum_call( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[20];
  if (nrhs<1 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the checksum */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"sf_get_check_sum"))
    return 0;
  plhs[0] = mxCreateDoubleMatrix( 1,4,mxREAL);
  if (nrhs>1 && mxIsChar(prhs[1])) {
    mxGetString(prhs[1], commandName,sizeof(commandName)/sizeof(char));
    commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
    if (!strcmp(commandName,"machine")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1676955763U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(262058301U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1210569671U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2350997557U);
    } else if (!strcmp(commandName,"exportedFcn")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0U);
    } else if (!strcmp(commandName,"makefile")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1640060053U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(917438938U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2369871927U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(550938579U);
    } else if (nrhs==3 && !strcmp(commandName,"chart")) {
      unsigned int chartFileNumber;
      chartFileNumber = (unsigned int)mxGetScalar(prhs[2]);
      switch (chartFileNumber) {
       case 1:
        {
          extern void sf_c1_sl_househeat_get_check_sum(mxArray *plhs[]);
          sf_c1_sl_househeat_get_check_sum(plhs);
          break;
        }

       case 2:
        {
          extern void sf_c2_sl_househeat_get_check_sum(mxArray *plhs[]);
          sf_c2_sl_househeat_get_check_sum(plhs);
          break;
        }

       case 4:
        {
          extern void sf_c4_sl_househeat_get_check_sum(mxArray *plhs[]);
          sf_c4_sl_househeat_get_check_sum(plhs);
          break;
        }

       case 6:
        {
          extern void sf_c6_sl_househeat_get_check_sum(mxArray *plhs[]);
          sf_c6_sl_househeat_get_check_sum(plhs);
          break;
        }

       case 7:
        {
          extern void sf_c7_sl_househeat_get_check_sum(mxArray *plhs[]);
          sf_c7_sl_househeat_get_check_sum(plhs);
          break;
        }

       default:
        ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0.0);
      }
    } else if (!strcmp(commandName,"target")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3031367619U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4001028638U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3978939492U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(838979348U);
    } else {
      return 0;
    }
  } else {
    ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1534437322U);
    ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2592384520U);
    ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1273308113U);
    ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(855413722U);
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_sl_househeat_autoinheritance_info( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[32];
  char aiChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the autoinheritance_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_autoinheritance_info"))
    return 0;
  mxGetString(prhs[2], aiChksum,sizeof(aiChksum)/sizeof(char));
  aiChksum[(sizeof(aiChksum)/sizeof(char)-1)] = '\0';

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        if (strcmp(aiChksum, "H4G4zy2Y6eMQTwJOBl7epH") == 0) {
          extern mxArray *sf_c1_sl_househeat_get_autoinheritance_info(void);
          plhs[0] = sf_c1_sl_househeat_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 2:
      {
        if (strcmp(aiChksum, "Vxx2LYtMIwcXkd7MSioIxF") == 0) {
          extern mxArray *sf_c2_sl_househeat_get_autoinheritance_info(void);
          plhs[0] = sf_c2_sl_househeat_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 4:
      {
        if (strcmp(aiChksum, "tb1lGYQhQf27lm8DopaAHG") == 0) {
          extern mxArray *sf_c4_sl_househeat_get_autoinheritance_info(void);
          plhs[0] = sf_c4_sl_househeat_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 6:
      {
        if (strcmp(aiChksum, "IuXOT6I4yuR0UIVOi6jslH") == 0) {
          extern mxArray *sf_c6_sl_househeat_get_autoinheritance_info(void);
          plhs[0] = sf_c6_sl_househeat_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 7:
      {
        if (strcmp(aiChksum, "isZjSpX4bGOBct3Pd4tneD") == 0) {
          extern mxArray *sf_c7_sl_househeat_get_autoinheritance_info(void);
          plhs[0] = sf_c7_sl_househeat_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_sl_househeat_get_eml_resolved_functions_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[64];
  if (nrhs<2 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the get_eml_resolved_functions_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_eml_resolved_functions_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        extern const mxArray *sf_c1_sl_househeat_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c1_sl_househeat_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 2:
      {
        extern const mxArray *sf_c2_sl_househeat_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c2_sl_househeat_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 4:
      {
        extern const mxArray *sf_c4_sl_househeat_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c4_sl_househeat_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 6:
      {
        extern const mxArray *sf_c6_sl_househeat_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c6_sl_househeat_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 7:
      {
        extern const mxArray *sf_c7_sl_househeat_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c7_sl_househeat_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_sl_househeat_third_party_uses_info( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{
  char commandName[64];
  char tpChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the third_party_uses_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  mxGetString(prhs[2], tpChksum,sizeof(tpChksum)/sizeof(char));
  tpChksum[(sizeof(tpChksum)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_third_party_uses_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        if (strcmp(tpChksum, "U2O6glhN4OcnNIkmrAd56B") == 0) {
          extern mxArray *sf_c1_sl_househeat_third_party_uses_info(void);
          plhs[0] = sf_c1_sl_househeat_third_party_uses_info();
          break;
        }
      }

     case 2:
      {
        if (strcmp(tpChksum, "XBHdZILgrnnXMuVDhDjkGC") == 0) {
          extern mxArray *sf_c2_sl_househeat_third_party_uses_info(void);
          plhs[0] = sf_c2_sl_househeat_third_party_uses_info();
          break;
        }
      }

     case 4:
      {
        if (strcmp(tpChksum, "mHAEqU2I0iSI38ebhW9gnF") == 0) {
          extern mxArray *sf_c4_sl_househeat_third_party_uses_info(void);
          plhs[0] = sf_c4_sl_househeat_third_party_uses_info();
          break;
        }
      }

     case 6:
      {
        if (strcmp(tpChksum, "WWZ9dsRaCSkQ7jwD9RFvu") == 0) {
          extern mxArray *sf_c6_sl_househeat_third_party_uses_info(void);
          plhs[0] = sf_c6_sl_househeat_third_party_uses_info();
          break;
        }
      }

     case 7:
      {
        if (strcmp(tpChksum, "FhgGhYtLHs7GSAddKZOOLH") == 0) {
          extern mxArray *sf_c7_sl_househeat_third_party_uses_info(void);
          plhs[0] = sf_c7_sl_househeat_third_party_uses_info();
          break;
        }
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;
}

unsigned int sf_sl_househeat_updateBuildInfo_args_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{
  char commandName[64];
  char tpChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the updateBuildInfo_args_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  mxGetString(prhs[2], tpChksum,sizeof(tpChksum)/sizeof(char));
  tpChksum[(sizeof(tpChksum)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_updateBuildInfo_args_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        if (strcmp(tpChksum, "U2O6glhN4OcnNIkmrAd56B") == 0) {
          extern mxArray *sf_c1_sl_househeat_updateBuildInfo_args_info(void);
          plhs[0] = sf_c1_sl_househeat_updateBuildInfo_args_info();
          break;
        }
      }

     case 2:
      {
        if (strcmp(tpChksum, "XBHdZILgrnnXMuVDhDjkGC") == 0) {
          extern mxArray *sf_c2_sl_househeat_updateBuildInfo_args_info(void);
          plhs[0] = sf_c2_sl_househeat_updateBuildInfo_args_info();
          break;
        }
      }

     case 4:
      {
        if (strcmp(tpChksum, "mHAEqU2I0iSI38ebhW9gnF") == 0) {
          extern mxArray *sf_c4_sl_househeat_updateBuildInfo_args_info(void);
          plhs[0] = sf_c4_sl_househeat_updateBuildInfo_args_info();
          break;
        }
      }

     case 6:
      {
        if (strcmp(tpChksum, "WWZ9dsRaCSkQ7jwD9RFvu") == 0) {
          extern mxArray *sf_c6_sl_househeat_updateBuildInfo_args_info(void);
          plhs[0] = sf_c6_sl_househeat_updateBuildInfo_args_info();
          break;
        }
      }

     case 7:
      {
        if (strcmp(tpChksum, "FhgGhYtLHs7GSAddKZOOLH") == 0) {
          extern mxArray *sf_c7_sl_househeat_updateBuildInfo_args_info(void);
          plhs[0] = sf_c7_sl_househeat_updateBuildInfo_args_info();
          break;
        }
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;
}

void sl_househeat_debug_initialize(struct SfDebugInstanceStruct* debugInstance)
{
  _sl_househeatMachineNumber_ = sf_debug_initialize_machine(debugInstance,
    "sl_househeat","sfun",0,5,0,0,0);
  sf_debug_set_machine_event_thresholds(debugInstance,
    _sl_househeatMachineNumber_,0,0);
  sf_debug_set_machine_data_thresholds(debugInstance,_sl_househeatMachineNumber_,
    0);
}

void sl_househeat_register_exported_symbols(SimStruct* S)
{
}

static mxArray* sRtwOptimizationInfoStruct= NULL;
mxArray* load_sl_househeat_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct==NULL) {
    sRtwOptimizationInfoStruct = sf_load_rtw_optimization_info("sl_househeat",
      "sl_househeat");
    mexMakeArrayPersistent(sRtwOptimizationInfoStruct);
  }

  return(sRtwOptimizationInfoStruct);
}

void unload_sl_househeat_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct!=NULL) {
    mxDestroyArray(sRtwOptimizationInfoStruct);
    sRtwOptimizationInfoStruct = NULL;
  }
}
